/*
Copyright (c) 2019-2023 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package k8s

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/k8s"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func utilityK8sListCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*k8s.ListK8S, error) {
	c := m.(*controller.ControllerCfg)
	req := k8s.ListRequest{}

	if by_id, ok := d.GetOk("by_id"); ok {
		req.ByID = uint64(by_id.(int))
	}
	if name, ok := d.GetOk("name"); ok {
		req.Name = name.(string)
	}
	if ip_address, ok := d.GetOk("ip_address"); ok {
		req.IPAddress = ip_address.(string)
	}
	if rg_id, ok := d.GetOk("rg_id"); ok {
		req.RGID = uint64(rg_id.(int))
	}
	if lb_id, ok := d.GetOk("lb_id"); ok {
		req.LBID = uint64(lb_id.(int))
	}
	if bservice_id, ok := d.GetOk("bservice_id"); ok {
		req.BasicServiceID = uint64(bservice_id.(int))
	}
	if status, ok := d.GetOk("status"); ok {
		req.Status = status.(string)
	}
	if tech_status, ok := d.GetOk("tech_status"); ok {
		req.TechStatus = tech_status.(string)
	}
	if includeDeleted, ok := d.GetOk("include_deleted"); ok {
		req.IncludeDeleted = includeDeleted.(bool)
	}
	if sortBy, ok := d.GetOk("sort_by"); ok {
		req.SortBy = sortBy.(string)
	}
	if page, ok := d.GetOk("page"); ok {
		req.Page = uint64(page.(int))
	}
	if size, ok := d.GetOk("size"); ok {
		req.Size = uint64(size.(int))
	}
	if zoneID, ok := d.GetOk("zone_id"); ok {
		req.ZoneID = uint64(zoneID.(int))
	}

	k8sList, err := c.CloudBroker().K8S().List(ctx, req)
	if err != nil {
		return nil, err
	}

	return k8sList, nil
}
